#!/usr/bin/env python
# -*- coding: utf-8 -*-

 
 
from PyQt4.QtCore import *
from PyQt4.QtGui import *
from PyKDE4.plasma import *
from PyKDE4.plasmascript import *
from PyKDE4.kdeui import *
from PyKDE4 import kdecore,kio


 
class MainApplet(Applet):
    def __init__(self,parent,args=None):
        Applet.__init__(self,parent)
        #super(MainApplet, self).__init__()
    def init(self):
        
        #self.setupAppletUi() if self.formFactor() == Plasma.Planar else self.setupPopupUi()
        self.setupPopupUi()
        
    def setupPopupUi(self):
        self.popup = Plasma.Dialog()
        self.popup.setWindowFlags(Qt.Popup)
        self.popup.setResizeHandleCorners( Plasma.Dialog.ResizeCorner(2))
        self.popupLayout = QVBoxLayout()
        self.popup.setLayout(self.popupLayout)

        self.view = kio.KFilePlacesView()
        self.model = kio.KFilePlacesModel(self)
        self.view.setModel(self.model)

        self.popupLayout.addWidget(self.view)
        self.popup.resize(300, 460)

        # Im Applet ein Icon anzeigen
        self.icon = Plasma.IconWidget(KIcon("folder-home"), "")
        #self.icon.setPreferredIconSize(QSizeF(48.0, 48.0))
        self.iconLayout = QGraphicsLinearLayout()
        self.iconLayout.addItem(self.icon)
        self.setAspectRatioMode(Plasma.ConstrainedSquare)
        self.applet.setLayout(self.iconLayout)
        
        QObject.connect(self.icon, SIGNAL("clicked()"), self, SLOT('togglePopup()'))
        #self.view.urlChanged.connect(self.open_place)
        QObject.connect(self.view, SIGNAL("urlChanged(const KUrl&)"), self, SLOT('open_place(const KUrl&)'))
    
    @pyqtSlot()
    def togglePopup(self):
        if self.popup.isVisible():
            self.popup.animatedHide(Plasma.Direction(1))
        else:
            self.popup.move(self.popupPosition(self.popup.sizeHint()))
            self.popup.animatedShow(Plasma.Direction(0))
    
    @pyqtSlot('const KUrl&')
    def open_place(self, url):
        self.popup.animatedHide(Plasma.Direction(1))
        run = kio.KRun(url, self.popup)
        run.runUrl(url, 'inode/directory', None) 
        
def CreateApplet(parent):
    return MainApplet(parent)
    